#
# This is a part of software for the algorithm described in
#
# Kuzborskij, I., Carlucci, F. M., Caputo, B.
# "When Naive Bayes Nearest Neighbours Meet Convolutional Neural Networks".
# In: Computer Vision and Pattern Recognition (CVPR), 2016 IEEE Conference on.
#
# Contact the author: ilja.kuzborskij [at] idiap.ch
#                     http://idiap.ch/~ikuzbor
#
# ----------------------------------------------------------------------------------
#
# Copyright (c) 2015 Idiap Research Institute, http://www.idiap.ch/
# Written by Ilja Kuzborskij <ilja.kuzborskij@idiap.ch>
#
# This file is part of STOML3.
#
# STOML3 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# STOML3 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with STOML3. If not, see <http://www.gnu.org/licenses/>.
#

import sys
import logging
import os
from os.path import join, exists, basename, splitext
from glob import glob
import uuid
from os import popen
from ConfigParser import ConfigParser

import numpy as np
from scipy.io import loadmat, savemat

def init_logging():
    logging.StreamHandler(sys.stdout)
    log = get_logger()
    log.setLevel(level=logging.DEBUG)

    stream = logging.StreamHandler()
    stream.setLevel(logging.DEBUG)
    formatter = logging.Formatter("[%(asctime)s] %(levelname)s: %(funcName)s: \"%(message)s\"",
                                  "%Y-%m-%d %H:%M:%S")
    stream.setFormatter(formatter)
    log.addHandler(stream)

def get_logger():
    return logging.getLogger('main')

def add_reg_bias(X_):
    m, d = X_.shape
    return np.hstack([X_, -np.ones( (m, 1) )])

