
from glob import glob
from SmoothML3 import SmoothML3
from data import Cifar10MinibatchLoader
from common import *

if __name__ == '__main__':
    init_logging()

    # Creates STOML3 instance
    cls = SmoothML3(lambda_=1.0,
                    n=10,
                    t0=1,
                    p=2.0,
                    L=1.0)

    CIFAR10_PATH = 'cifar-10-batches-mat/'

    # Initializes loader which will supply minibatches to STOML3
    train_loader = Cifar10MinibatchLoader(files=glob(CIFAR10_PATH+'data_batch*.mat'),
                                          passes=10)
    train_loader.init_scaler()

    # Train...
    cls.fit_from_loader(loader=train_loader,
                        num_classes=10)

    # Test... (test minibatches are also loaded out-of-core)
    test_loader = Cifar10MinibatchLoader(files=[CIFAR10_PATH+'test_batch.mat'],
                                         passes=1,
                                         scaler=train_loader.scaler)
    
    print 'Accuracy: %.3f.' % cls.score_from_loader(loader=test_loader)
    print 'Train time (without I/O): %.3f (s).' % (cls.train_time_ms/1000)
    print 'Test time (without I/O): %.3f (s).' % (cls.test_time_ms/1000)
